import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Properties;
import javax.print.*;
import javax.print.attribute.*;
import com.sun.image.codec.jpeg.*;
import java.awt.image.*;
import javax.imageio.*;
import java.util.*;
import java.net.*;

public class TestPrintNewJPSIMAGE extends Frame {
    
  private final String ConfigFilename = "TestPrintNewJPSIMAGE.cfg";
  private final String resourceDIR  = File.separator+"redstone"+File.separator+"resource";
  private JTextArea textArea;
  private JFrame frame;

  private JLabel statusInfo;
  private JButton printButton, closeButton;
    private Properties p = new Properties();
    private PageAttributes pa= new PageAttributes();
    private JobAttributes ja= new JobAttributes();
    
    private String filename;
    private int pleft;
    private int pright;
    private int ptop;
    private int pbottom;
    //private Font helv;
    private int verbose;
    private int dialogL;
    private int destL;
    private int showF;
    private String outfilenameL;
      
    //have to set the font to get any output
    private Font Ahelv;
    private FontMetrics fm ;
    private int fontHeight ;
    private int fontDescent ;
    private int     fontAscent;
	private int pageHeight ;
   // private     int pageNum = 1;
   // private     int linesForThisPage = 0;
   // private       int linesForThisJob = 0;
    private     int pageNum = 0;
    private     int linesForThisPage = 0;
    private       int linesForThisJob = 0;
    private int URLTextNum= 0;
    private int URLImageNum= 0;
    private int ImageNum= 0;
    private int TextNum= 0;
    private Graphics pg;
    private boolean V_URL=false;
    private boolean V_FONT=false;
    private boolean V_ENC=false;
    

private enum _PrintQualityType { DRAFT,NORMAL,HIGH ,
		                 PORTRAIT, LANDSCAPE ,
		                 COLOR, MONOCHROME ,
		                 A2,A3, A4 ,A5,B2,B3,B4,B5,LETTER,
	                         ONE_SIDED,TWO_SIDED_LONG_EDGE,TWO_SIDED_SHORT_EDGE,
	                         V_URL,
                                 V_FONT,
                                 V_ENC
                               }

public void _setPrintQuality(_PrintQualityType enm){
switch (enm) {

case DRAFT: pa.setPrintQuality(PageAttributes.PrintQualityType.DRAFT);break;
case NORMAL: pa.setPrintQuality(PageAttributes.PrintQualityType.NORMAL);break;
case HIGH: pa.setPrintQuality(PageAttributes.PrintQualityType.HIGH);break;
case PORTRAIT: pa.setOrientationRequested(PageAttributes.OrientationRequestedType.PORTRAIT);break;
case LANDSCAPE: pa.setOrientationRequested(PageAttributes.OrientationRequestedType.LANDSCAPE);break;
case COLOR: pa.setColor(PageAttributes.ColorType.COLOR);break;
case MONOCHROME: pa.setColor(PageAttributes.ColorType.MONOCHROME);break;
case A2: pa.setMedia(PageAttributes.MediaType.A2);break;
case A3: pa.setMedia(PageAttributes.MediaType.A3);break;
case A4: pa.setMedia(PageAttributes.MediaType.A4);break;
case A5: pa.setMedia(PageAttributes.MediaType.A5);break;
case B2: pa.setMedia(PageAttributes.MediaType.B2);break;
case B3: pa.setMedia(PageAttributes.MediaType.B3);break;
case B4: pa.setMedia(PageAttributes.MediaType.B4);break;
case B5: pa.setMedia(PageAttributes.MediaType.B5);break;
case LETTER: pa.setMedia(PageAttributes.MediaType.LETTER);break;
case ONE_SIDED: ja.setSides(JobAttributes.SidesType.ONE_SIDED);break;
case TWO_SIDED_LONG_EDGE: ja.setSides(JobAttributes.SidesType.TWO_SIDED_LONG_EDGE);break;
case TWO_SIDED_SHORT_EDGE: ja.setSides(JobAttributes.SidesType.TWO_SIDED_SHORT_EDGE);break;
case V_URL: V_URL=true;break;
case V_FONT: V_FONT=true;break;
case V_ENC: V_ENC=true;break;

default :
}
}	
///////////////////////////////////////////////////////////////
private void _readCONFIG(String fileName) {
//System.out.println("xxxxxxxxxxxxxxxxxx = "+TestPrintNewJPSIMAGE.class.getName());
//System.out.println("xxxxxxxxxxxxxxxxxx = "+File.pathSeparator);
//System.out.println("xxxxxxxxxxxxxxxxxx = "+File.separator);
//System.out.println("xxxxxxxxxxxxxxxxxx = "+System.getProperty("user.dir"));
/*
This was originally reported as related bugs 4117557 as 4483097 and was 
*incorrectly* closed by the responsible engineer. All the client/user 
comments (below the main text of  the 4483097 bug report state this). 
The engineer's comments were:
  " Not a bug.  If you need to resolve a filename against the value of
the "user.dir" system property then you must use getAbsolutePath (or
getAbsoluteFile, or getCanonicalPath, or getCanonicalFile).  Simpler
operations such as exists() always resolve against the directory in
which the Java virtual machine was originally invoked (and no, there
is no way to change that).
*/

  String line = "";
  String cfg = "";
  ArrayList data = new ArrayList();
  try {

File f = new File(System.getProperty("user.dir")+File.separator+fileName);
//System.out.println("xxxxxxifxxxxxxxxxxxx = "+(f.exists() && f.canWrite() && f.canRead()));


if (f.exists() && f.canRead())
cfg=f.getPath(); else cfg=System.getProperty("user.home")+resourceDIR+File.separator+fileName;

System.out.println("Reading config = "+cfg);

//System.out.println("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx");


   FileReader fr = new FileReader(cfg);
   BufferedReader br = new BufferedReader(fr);
   while((line = br.readLine()) != null) {
   if (line.length()!=0)
   _setPrintQuality(_PrintQualityType.valueOf(line));
//System.out.println("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx");
//System.exit(0);
   }
  }
  catch(FileNotFoundException fe) {
   System.out.println("File not exists. Not using TestPrintNewJPSIMAGE.cfg.");
  }
  catch(IOException e) {
   System.out.println("File not exists. Not using TestPrintNewJPSIMAGE.cfg.");
  }
  catch(NullPointerException e) {
   System.out.println("File not exists. Not using TestPrintNewJPSIMAGE.cfg.");
  }
 }
///////////////////////////////////////////////////////////////////////////////////////    

public TestPrintNewJPSIMAGE(String _filename,int _pleft,int _pright,int _ptop,int _pbottom,Font _helv,
				int _verbose,int _dialogL,int _destL,int _showF,String _outfilenameL) {
	//    public TestPrintNewJPSIMAGE() {

	
	
    super ("Print to file");
    this.frame = new JFrame();
    add (statusInfo = new JLabel(), "North");
	JPanel p = new JPanel ();
	
    //p.add (loadButton = new Button ("Load"));
    //loadButton.addActionListener( new LoadFileCommand() );
    //p.add (printButton = new Button ("Print"));
    //printButton.addActionListener( new PrintCommand() );
    p.add (printButton = new JButton ("Print"));
    printButton.addActionListener( new PrintCommand());
    p.add (closeButton = new JButton ("Close"));
    closeButton.addActionListener( new CloseCommand() );        
    add (p, "South");
    textArea = new JTextArea (10, 20);
    JScrollPane scrollPane = new JScrollPane(textArea);	
    add (scrollPane, "Center");
	
    pack();
	
    filename=_filename;
    pleft=_pleft;
    pright=_pright;
    ptop=_ptop;
    pbottom=_pbottom;
    Ahelv=_helv;
    verbose=_verbose;
    dialogL=_dialogL;
    destL=_destL;
    showF=_showF;
    outfilenameL=_outfilenameL;	
    System.out.println(" ");
  
	    _readCONFIG(ConfigFilename);

	//_setPrintQuality(_PrintQualityType.valueOf("HIGH"));
	//_setPrintQuality(_PrintQualityType.valueOf("PORTRAIT"));
	
	if (dialogL==1) ja.setDialog( JobAttributes.DialogType.NONE);
	
	if (destL==1) ja.setDestination( JobAttributes.DestinationType.FILE);
	
	if (outfilenameL!=null) ja.setFileName(outfilenameL);
    
    if (checkURL(filename)==false) {PrintL(filename,_getCharset(filename,0));}
    else {PrintURL(filename,_getCharset(filename,1));}
    System.out.println(" ");
	
	
	if (showF==0 ){
	    PrintCommandL(filename,outfilenameL,pleft,pright,ptop,pbottom,Ahelv,verbose) ;
	    System.exit(0);
	}
	    
        
	
	//PrintLFPS(filename,textArea);
	    

} 
///////////////////////////////////////////////////////////////////////////////////////    
  class PrintCommand implements ActionListener {
      public void actionPerformed (ActionEvent e) {
      //  }
	 

    //if (checkURL(filename)==false) {PrintL(filename,_getCharset(filename,0));}
    //else {PrintURL(filename,_getCharset(filename,1));}
	PrintCommandL(filename,outfilenameL,pleft,pright,ptop,pbottom,Ahelv,verbose) ;
	
      }
  }
///////////////////////////////////////////////////////////////////////////////////////    
private void PrintLFPS(String filename,TextArea ta) {//throws Exception 

System.exit(0);

	
    }
///////////////////////////////////////////////////////////////////////////////////////    
    private boolean checkURL(String filename){
	boolean i = true;
    try {
	URL aURL = new URL(filename); 
	/*
        System.out.println("protocol = " + aURL.getProtocol());
	System.out.println("authority = " + aURL.getAuthority());
        System.out.println("host = " + aURL.getHost());
        System.out.println("port = " + aURL.getPort());
        System.out.println("path = " + aURL.getPath());
        System.out.println("query = " + aURL.getQuery());
        System.out.println("filename = " + aURL.getFile());
	   System.out.println("ref = " + aURL.getRef());
	**/ 
    }catch (MalformedURLException exc) {
	i= false;
    }  
	
     if (V_URL)    System.out.println("checkURL ("+filename+") = " + i);
	return i;
 }
///////////////////////////////////////////////////////////////////////////////////////   
private String _getCharset(String filename,int fileType) {

String r="OTHER";
SinoDetect sd =   new SinoDetect();

if (fileType==0) {File F = new File (filename);
r=Encoding.javaname[sd.detectEncoding(F)];} 
else {
    try {
URL url = new URL(filename);
r=Encoding.javaname[sd.detectEncoding(url)];
    }catch (ArrayIndexOutOfBoundsException exc) {
	
    }catch (MalformedURLException exc) {
	
    }  

}

if (V_ENC) System.out.println (r+ " for "+filename);

//System.out.println ("xxxxxxxxxxxxxxxxxxx1====   ");
//System.out.println ("xxxxxxxxxxxxxxxxxxx2====   ");

return r;
	
}
    
///////////////////////////////////////////////////////////////////////////////////////   
private void PrintURL(String filename,String _charset) {
        StringBuffer sb= new StringBuffer();
    String n = System.getProperty("line.separator");
 
try {
	URL url = new URL(filename);
	BufferedReader in = new BufferedReader(new InputStreamReader(url.openStream(),_charset));

	String inputLine;

	while ((inputLine = in.readLine()) != null){
              sb.append(inputLine+n);
	    //System.out.println(inputLine);
         }

	in.close();    

    }catch (MalformedURLException exc) {
	String errorString = "File Not Found: " + filename;
        sb.append(errorString+n);
    }catch (IOException exc) {
        String errorString = "File Not Found: IOException: " + filename;     
        sb.append(errorString+n);
    } 

        textArea.setText (new String (sb));
        setCursor (Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));


}
///////////////////////////////////////////////////////////////////////////////////////   
private void PrintL(String filename,String _charset){
   //char[] data=null;
  //         int state;
        StringBuffer sb= new StringBuffer();
      String msg;
    String n = System.getProperty("line.separator");
	    
      //FileDialog file = new FileDialog (TestPrintNew.this, "Load File", FileDialog.LOAD);
      //file.setFile ("*.*");  // Set initial filename filter
      //file.show(); // Blocks
      //String curFile;
      if (filename != null) {
	  //String filename = file.getDirectory() + curFile;
	  
    File F = new File (filename);
        try {
	    	    
        InputStream f = new FileInputStream (filename);
	BufferedReader in = new BufferedReader(new InputStreamReader(f,_charset));
	String inputLine;
	

	while ((inputLine = in.readLine()) != null){
	    //sb.append(inputLine+n);
	    sb.append(inputLine+n);
//          FileReader fin = new FileReader (f);
//          int filesize = (int)f.length();
//          data = new char[filesize];
	    //          fin.read (data, 0, filesize);
	     }
	in.close();    
        } catch (FileNotFoundException exc) {
          String errorString = "File Not Found: " + filename;
          sb.append(errorString+n);
        } catch (IOException exc) {
          String errorString = "IOException: " + filename;
          sb.append(errorString+n);
        }
        
     
       // textArea.setText (new String (data));
        textArea.setText (new String (sb));
        setCursor (Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
  
      } 
    
     }
	
	
///////////////////////////////////////////////////////////////////////////////////////    
private String getDataL(String filename,String _charset){
   //char[] data=null;
  //         int state;
    StringBuffer sb= new StringBuffer();
    //InputStreamReader sr= new InputStreamReader;
      String msg;
    String n = System.getProperty("line.separator");
      //FileDialog file = new FileDialog (TestPrintNew.this, "Load File", FileDialog.LOAD);
      //file.setFile ("*.*");  // Set initial filename filter
      //file.show(); // Blocks
      //String curFile;
      if (filename != null) {
	  //String filename = file.getDirectory() + curFile;
	  
        
        try {
	    InputStream f = new FileInputStream (filename);
	    
	    
 	BufferedReader in = new BufferedReader(new InputStreamReader(f,_charset));
 	String inputLine;

	while ((inputLine = in.readLine()) != null){
              sb.append(inputLine+n);
//          FileReader fin = new FileReader (f);
//          int filesize = (int)f.length();
//          data = new char[filesize];
	    //          fin.read (data, 0, filesize);
	     }
	    in.close(); 
	    
        } catch (FileNotFoundException exc) {
          String errorString = "File Not Found: " + filename;
          sb.append(errorString+n);
          //data = errorString.toCharArray ();
        } catch (IOException exc) {
          String errorString = "IOException: " + filename;
          sb.append(errorString+n);
          //data = errorString.toCharArray ();
        }
        
        
      } 
msg=new String (sb);
    return msg;
     }
	
	

///////////////////////////////////////////////////////////////////////////////////////    
private String getDataURL(String filename,String _charset){
        StringBuffer sb= new StringBuffer();
    String msg;
    String n= System.getProperty("line.separator");
try {
	URL url = new URL(filename);
	BufferedReader in = new BufferedReader(new InputStreamReader(url.openStream(),_charset));

	String inputLine;

	while ((inputLine = in.readLine()) != null){
              sb.append(inputLine+n);
	    //System.out.println(inputLine);
         }

	in.close();    

    }catch (MalformedURLException exc) {
	String errorString = "File Not Found: " + filename;
        sb.append(errorString+n);
    }catch (IOException exc) {
        String errorString = "IOException: " + filename;     
        sb.append(errorString+n);
    }

msg=new String (sb);
    return msg;
}
///////////////////////////////////////////////////////////////////////////////////////    
private void PrintCommandL(String filename,String outfilenameL,int pleft,int pright,int ptop,int pbottom,Font helv,int verbose)  {
	
      System.out.println ("[PRINT TO FILE][Start...][from "+filename+"][to "+outfilenameL+"]");

      PrintJob pjob = getToolkit().getPrintJob(TestPrintNewJPSIMAGE.this, "Print to file", ja,pa);
    
    //if (verbose>0){
      System.out.println (" ");
      System.out.println ("getCopies"+" "+ja.getCopies());
      System.out.println ("getDefaultSelection"+" "+ja.getDefaultSelection());
      System.out.println ("getDestination"+" "+ja.getDestination());
      System.out.println ("getDialog"+" "+ja.getDialog());
      System.out.println ("getFileName"+" "+ja.getFileName());
      System.out.println ("getFromPage"+" "+ja.getFromPage());
      System.out.println ("getMaxPage"+" "+ja.getMaxPage());
      System.out.println ("getMinPage"+" "+ja.getMinPage());
      System.out.println ("getMultipleDocumentHandling"+" "+ja.getMultipleDocumentHandling());
      System.out.println ("getPageRanges"+" "+ja.getPageRanges());
      System.out.println ("getPrinter"+" "+ja.getPrinter());
      System.out.println ("getSides"+" "+ja.getSides());
      System.out.println ("getToPage"+" "+ja.getToPage());
      
      System.out.println ("getColor"+" "+pa.getColor());
      System.out.println ("getMedia"+" "+pa.getMedia());
      
      System.out.println ("getOrientationRequested"+" "+pa.getOrientationRequested());
      System.out.println ("getOrigin"+" "+pa.getOrigin());
      System.out.println ("getPrinterResolution"+" "+pa.getPrinterResolution().hashCode());
      System.out.println ("getPrintQuality"+" "+pa.getPrintQuality());
      System.out.println (" ");
    //}
/*
      System.out.println ("PrintQualityType.DRAFT"+" "+PageAttributes.PrintQualityType.DRAFT.hashCode());
      System.out.println ("PrintQualityType.NORMAL"+" "+PageAttributes.PrintQualityType.NORMAL.hashCode());
      System.out.println ("PrintQualityType.HIGH"+" "+PageAttributes.PrintQualityType.HIGH.hashCode());
      System.out.println ("OrientationRequestedType.LANDSCAPE"+" "+PageAttributes.OrientationRequestedType.LANDSCAPE.hashCode());
    System.out.println ("OrientationRequestedType.PORTRAIT"+" "+PageAttributes.OrientationRequestedType.PORTRAIT.hashCode());
    System.out.println ("PageAttributes.ColorType.COLOR"+" "+PageAttributes.ColorType.COLOR.hashCode());
    System.out.println ("PageAttributes.ColorType.MONOCHROME"+" "+PageAttributes.ColorType.MONOCHROME.hashCode());
    System.out.println ("PageAttributes.MediaType.A3"+" "+PageAttributes.MediaType.A3.hashCode());
    System.out.println ("PageAttributes.MediaType.A4"+" "+PageAttributes.MediaType.A4.hashCode());
    System.out.println ("PageAttributes.MediaType.A5"+" "+PageAttributes.MediaType.A5.hashCode());
*/			
    
    
///////////////////////////////////////////////////////////////////////////////////////       
    if (pjob != null) {
  //Graphics pg = pjob.getGraphics();
	      //System.out.println ("pg"+" "+pg);

pg = pjob.getGraphics().create(pleft,ptop,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));   //pg = pjob.getGraphics();
	//pg = pg.create(pleft,ptop,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));   
	//pg = pjob.getGraphics();
//pg.drawRect(0,0,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));
//        if (pg != null) {
	String s=textArea.getText();
	
	      //int pageHeight = pjob.getPageDimension().height - margin;
	      //int pageHeight = (pg.getClipBounds().height);
 pageHeight = pjob.getPageDimension().height - (ptop+pbottom);
      
    //have to set the font to get any output
    pg.setFont (Ahelv);
    fm = pg.getFontMetrics(Ahelv);
    fontHeight = fm.getHeight();
     fontDescent = fm.getDescent();
     fontAscent = fm.getAscent();

//	          if (verbose>0){
      System.out.println ("pageWidth "+pjob.getPageDimension().width);
      System.out.println ("pageHeight "+pjob.getPageDimension().height);
      //System.out.println ("pageWidth-CLIPwidth "+(pg.getClipBounds().width));
      //System.out.println ("pageHeight-CLIPheight "+pageHeight);
      //System.out.println ("pageWidth-CLIPx "+(pg.getClipBounds().x));
      //System.out.println ("pageHeight-CLIPy "+pg.getClipBounds().y);
      System.out.println ("pageWidth - (pright+pleft) "+(pjob.getPageDimension().width- (pright+pleft)));
      System.out.println ("pageHeight - (ptop+pbottom) "+(pjob.getPageDimension().height- (ptop+pbottom)));
      //Font helv = new Font("Helvetica", Font.PLAIN, 12);
      System.out.println ("getFontName "+pg.getFont().getFontName());
      System.out.println ("getFontSize "+pg.getFont().getSize());
      System.out.println ("fontHeight "+fontHeight);
      System.out.println ("fontDescent "+fontDescent);
      System.out.println (" ");
//		  }
	   
	    //printLongString (pg,pjob,s,pleft,pright,ptop,pbottom,helv,verbose,1,0,0,0);
	     printLongString (pg,pjob,s,pleft,pright,ptop,pbottom,helv,verbose,1,0,0,0);
	          

      //  }
	pg.dispose();
	
	  pjob.end();
	  
    
      } 
    
	        System.out.println ("printung page number " + pageNum );
    System.out.println (" ");
    System.out.println ("total text files loaded: " + TextNum);
    System.out.println ("total text files from url : " + URLTextNum);
    System.out.println ("total image files loaded: " + ImageNum);
    System.out.println ("total image files from url : " + URLImageNum);
    System.out.println ("total lines printed: " + linesForThisJob);
    System.out.println ("pages printed: " + pageNum);
    System.out.println (" ");

  	System.out.println ("[PRINT TO FILE][End]");
   
  }
	    
///////////////////////////////////////////////////////////////////////////////////////       
private void V_FONT (String s,Graphics g) {

if (V_FONT) {
      System.out.println ("["+s+"] getFontName "+g.getFont().getFontName());
      System.out.println ("["+s+"] getFontStyle "+g.getFont().getStyle());
      System.out.println ("["+s+"] getFontSize "+g.getFont().getSize());
      System.out.println ("["+s+"] getFontHeight "+fm.getHeight());
      System.out.println ("["+s+"] getFontDescent "+fm.getDescent());
      System.out.println ("["+s+"] page number " + pageNum );
}         	
}
///////////////////////////////////////////////////////////////////////////////////////       
    public static void main (String args[])  {
	 //java TestPrintNewJPS /00000.txt 25 15 50 72 Helvetica 10 1 1 1 1 /00000.ps 

	String FfilenameL=args[0];
	 int Fpleft=Integer.parseInt(args[1]);
         int Fpright=Integer.parseInt(args[2]);
         int Fptop=Integer.parseInt(args[3]);
	int Fpbottom=Integer.parseInt(args[4]);
	Font Fhelv=new Font(args[5],Font.PLAIN,Integer.parseInt(args[6]));
	// Font helv = new Font("Helvetica", Font.PLAIN, 12);
	 //int Ffpt=Integer.parseInt(args[6]);
	 int Fverbose=Integer.parseInt(args[7]);
	 int FdialogL=Integer.parseInt(args[8]);
	 int FdestL=Integer.parseInt(args[9]);
	 int FshowF=Integer.parseInt(args[10]);

         String FoutfilenameL=args[11];
	
	/*
	 * public static Font decode(String str)
	
	   in which style is one of the three case-insensitive strings: "BOLD", "BOLDITALIC", or "ITALIC", and pointsize 
	   is a decimal representation of the point size. For example, if you want a font that is Arial, bold, and a 
	   point size of 18, you would call this method with: "Arial-BOLD-18". 

           The default size is 12 and the default style is PLAIN. If you don't specify a valid size, the returned Font 
	   has a size of 12. If you don't specify a valid style, the returned Font has a style of PLAIN. If you do not 
	   provide a valid font family name in the str argument, this method still returns a valid font with a family 
	   name of "dialog". To determine what font family names are available on your system, use the 
	   GraphicsEnvironment.getAvailableFontFamilyNames() method. If str is null, a new Font is returned with the 
	   family name "dialog", a size of 12 and a PLAIN style. If str is null, a new Font is returned with the name 
	   "dialog", a size of 12 and a PLAIN style.
	 * 
	 * 
	 * 
	   ("Serif", Font.BOLD, 14)
           ("SansSerif", Font.BOLD + Font.ITALIC, 24)
           ("Monospaced", Font.PLAIN, 20)
           ("Dialog", Font.PLAIN, 30)
           ("Serif", Font.ITALIC, 36)
	 * 
	 * */
	
	TestPrintNewJPSIMAGE f = new TestPrintNewJPSIMAGE(FfilenameL,Fpleft,Fpright,Fptop,Fpbottom,Fhelv,Fverbose,FdialogL,FdestL,
							  FshowF,FoutfilenameL);
		
//	TestPrintNewJPSIMAGE f = new TestPrintNewJPSIMAGE();
	if (FshowF==1) {f.setSize(600,500);f.show();}
	if (FshowF==0) System.exit (0);
    
  }
///////////////////////////////////////////////////////////////////////////////////////       
   // Bail Out
  class CloseCommand implements ActionListener {
    public void actionPerformed (ActionEvent e) {
      System.exit (0);
    }
  }

///////////////////////////////////////////////////////////////////////////////////////    
  // I'm assuming a one-inch margin on all
  // four sides. This could be done better.
    private int margin = 0;
    private int curHeight = 0;
  private String imgfile ;
  // Print string to graphics via printjob
    // Does not deal with word wrap or tabs
    private Font Fhelv;
    private int _Fontheight;
    private int _FontDescent;
    private int _FontLeading;
    //private Font _Ahelv;
    
    //private FontMetrics _fm ;

    private int G_curHeight;
    private int FSize;
    private int FStyle;
    private int index;
    private String FInside;
    private String imgfileS;
    


private void printLongString (Graphics pg,PrintJob pjob, String s,int pleft,int pright,int ptop,int pbottom,Font helv,int verbose
				  ,int pageNumL,int linesForThisPageL,int linesForThisJobL,int continueL) {
    
    //int pageNum = 1;
    //int linesForThisPage = 0;
    //int linesForThisJob = 0;
    if (continueL==0) curHeight = 0; 
    pageNum = pageNumL;
    linesForThisPage = linesForThisPageL;
    linesForThisJob = linesForThisJobL;
    //pg = pgL;
TextNum++;
//Graphics pg = pjob.getGraphics().create(pleft,ptop,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));   //pg = pjob.getGraphics();
  //pg = pg.create(pleft,ptop,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop)); 
      
    // Note: String is immutable so won't change while printing.
    if (!(pg instanceof PrintGraphics)) {
      throw new IllegalArgumentException ("Graphics context not PrintGraphics");
}
   
    StringReader sr = new StringReader (s);
   // LineNumberReader lnr = new LineNumberReader (sr);
 BufferedReader lnr = new BufferedReader (sr);
    String nextLine;
    
    //pg.setFont (helv);
             
    V_FONT ("printLongString",pg);	

    //curHeight = curHeight+margin;   
    try {
      do {
	  nextLine = lnr.readLine();
	 
	  if (nextLine != null ) {
	      
	      if ((curHeight + fontHeight) > pageHeight) {
            // New Page
	      //System.out.println ("" + linesForThisPage + " lines printed for page " + pageNum);
	      
            if (linesForThisPage == 0) {
                                System.out.println ("Font is too big for pages of this size; aborting...");
		                break;
	                        }
  
	        System.out.println ("printing page number " + pageNum );
	    pageNum++;
            linesForThisPage = 0;
	    pg.dispose();
	   
	    pg = pjob.getGraphics();     
	    pg = pg.create(pleft,ptop,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));
	  //pg.drawRect(0,0,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));

   
      	   if (pg != null) {  pg.setFont (helv);  }
	  
	      curHeight = margin;    
	      //imageht = 0;
	      
          }//if ((curHeight + fontHeight) > pageHeight)
	    //curHeight += (fontHeight);
	    if (pg != null) {
		      if (verbose>0){
		      System.out.println ("margin "+margin);
		      System.out.println ("fontHeight "+fontHeight);
                      System.out.println ("curHeight "+curHeight);
                      System.out.println ("curHeight-fontDescent "+(curHeight - fontDescent));
		      }
//*****************************************************************************************************************//	   
// loadTextfile
//*****************************************************************************************************************//	   
		//substring(int beginIndex, int endIndex) length()
		if ((nextLine.trim()).indexOf("{loadTextfile=")>-1) {
		    
		    imgfile = nextLine.trim();
		    imgfile = imgfile.substring(imgfile.indexOf("=")+1,imgfile.length()-1);

      V_FONT ("loadTextfile",pg);	
	//if ((pageNum == 1)&&(curHeight!=0)) {curHeight += (fontHeight);}
        //else if ((pageNum != 1)&&(curHeight!=0)){curHeight += (fontHeight);}

if (checkURL(imgfile)==false) { 
 printLongString ( pg,pjob,getDataL(imgfile,_getCharset(imgfile,0)), pleft, pright, ptop, pbottom, helv, verbose
		   , pageNum, linesForThisPage, linesForThisJob, 1);
 //curHeight -= (fontHeight);  
}else { printLongString ( pg,pjob,getDataURL(imgfile,_getCharset(imgfile,1)), pleft, pright, ptop, pbottom, helv, verbose
		   , pageNum, linesForThisPage, linesForThisJob, 1);
 //curHeight -= (fontHeight);  
URLTextNum++;
}
// printLongString ( pg,pjob,getDataL(imgfile.substring(imgfile.indexOf("=")+1,imgfile.length()-1)), pleft, pright, ptop, pbottom, helv, verbose
//		   , pageNum, linesForThisPage, linesForThisJob, continueL);

	continue;
		
//*****************************************************************************************************************//	   
// loadImage
//*****************************************************************************************************************//	   
		}else if  ((nextLine.trim()).indexOf("{loadImage=")>-1) {
		//substring(int beginIndex, int endIndex) length()
    
		    
		    imgfile = nextLine.trim();   
                    imgfile = imgfile.substring(imgfile.indexOf("=")+1,imgfile.length()-1);

                    Image myImage2 =null;

try {

if (checkURL(imgfile)==false){

        File file = new File(imgfile);
        myImage2 = ImageIO.read(file);
	 //myImage2 = ImageUtil.loadImage(file);   
		    
}else {
        URL url = new URL(imgfile);
        myImage2 = ImageIO.read(url);
        URLImageNum++;
}
//+fontHeight+fontDescent
		    if ((curHeight + myImage2.getHeight(this)+fontDescent ) > pageHeight){
			//System.out.println ("" + linesForThisPage + " lines printed for page " + pageNum);
	        System.out.println ("printing page number " + pageNum );
		pageNum++;
            linesForThisPage = 0;
	    pg.dispose();
	   
	    pg = pjob.getGraphics();     
	    pg = pg.create(pleft,ptop,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));
	  //pg.drawRect(0,0,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));

   
      	   if (pg != null) {  pg.setFont (helv);  }
	  
			curHeight = margin;
			//curHeight += (fontHeight);
		    }
	      
	//System.out.println (myImage2.getWidth(this));
	//System.out.println (myImage2.getHeight(this));

	//if (curHeight==0) curHeight -= fontHeight; 

    V_FONT ("loadImage",pg);	
    
        //G_curHeight=0;
	if ((pageNum == 1)&&(curHeight!=0)) {curHeight+=fontDescent;}
        else if ((pageNum != 1)&&(curHeight!=0)){curHeight+=fontDescent;}
        //{G_curHeight=fontHeight;}
     //   {G_curHeight = fontDescent;}
         // curHeight += (fontHeight);
            
	pg.drawImage(myImage2, margin, curHeight , myImage2.getWidth(this),myImage2.getHeight(this),this);  
	//pg.drawImage(myImage2, margin, curHeight-fontHeight , myImage2.getWidth(this),myImage2.getHeight(this),this);  
		    curHeight = curHeight+myImage2.getHeight(this);
		    //curHeight = curHeight+150;
			//curHeight -= (fontHeight+G_curHeight)-fontDescent;
    ImageNum++;	
    pg.setFont (helv);
		continue;  
    } catch (IOException e) {
    }
//*****************************************************************************************************************//	   
// loadNewPage
//*****************************************************************************************************************//	   
		}else if ((nextLine.trim()).indexOf("{loadNewPage}")>-1) {

if (curHeight!=0){
	        System.out.println ("printing page number " + pageNum );
	    pageNum++;
            linesForThisPage = 0;
	    pg.dispose();
	   
	    pg = pjob.getGraphics();     
	    pg = pg.create(pleft,ptop,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));
//pg.drawRect(0,0,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));

      V_FONT ("loadNewPage",pg);	
  
   
      	   if (pg != null) {  pg.setFont (helv);  }
	  
	      curHeight = margin;    
	      //imageht = 0;
	}     
continue;

//*****************************************************************************************************************//	   
// loadFont
//*****************************************************************************************************************//	   
}else if ((nextLine.trim()).indexOf("{loadFont=")>-1) {
    //FFhelv=new Font(args[5],Font.BOLD,Integer.parseInt(args[6]));
//"{loadFont=PLAIN,14}"  = 0  
//"{loadFont=BOLD,14}"   = 1 
//"{loadFont=ITALIC,14}" = 2   
//"{loadFont=BOLD+ITALIC,14}" = 3
//    System.out.println ("====BOLD============================ "+Font.BOLD);
//    System.out.println ("====ITALIC============================ "+Font.ITALIC);
//    System.out.println ("====PLAIN============================ "+Font.PLAIN);
//    System.out.println ("====BOLD+ITALIC============================ "+Font.BOLD+ITALIC);
    
    imgfileS = nextLine.trim(); 
    
    imgfile = imgfileS.substring(imgfileS.indexOf("}")+1,imgfileS.length()); 
    //System.out.println ("====imgfile============================ "+imgfile);
    
    FInside = imgfileS.substring(imgfileS.indexOf("=")+1,imgfileS.indexOf("}")).trim();
    //System.out.println ("====FInside 1,14 ============================ "+FInside);
    
    index=FInside.indexOf(","); 
    FStyle = Integer.parseInt(FInside.substring(0,index).trim()); 
    FSize = Integer.parseInt(FInside.substring(index+1,FInside.length()).trim()); 
    //System.out.println ("====FStyle 1 ============================ "+FStyle);
    //System.out.println ("====FSize 14 ============================ "+FSize);
    //fm = pg.getFontMetrics(helv);
    //fontHeight = fm.getHeight();
     //fontDescent = fm.getDescent();    
    //curHeight += (fontHeight);
    //_Ahelv=helv;
    Fhelv=helv.deriveFont(FStyle,FSize);
    pg.setFont (Fhelv);
    fm = pg.getFontMetrics(Fhelv);
    _Fontheight=fm.getHeight();
    _FontDescent=fm.getDescent();
     _FontLeading=fm.getLeading();
	    V_FONT ("loadFont",pg);	
		
    
	      if ((curHeight + _Fontheight) > pageHeight) {
            // New Page
	      //System.out.println ("" + linesForThisPage + " lines printed for page " + pageNum);
	      
            if (linesForThisPage == 0) {
                                System.out.println ("Font is too big for pages of this size; aborting...");
		                break;
	                        }
  
	        System.out.println ("printing page number " + pageNum );
	    pageNum++;
            linesForThisPage = 0;
	    pg.dispose();
	   
	    pg = pjob.getGraphics();     
	    pg = pg.create(pleft,ptop,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));
	  //pg.drawRect(0,0,pjob.getPageDimension().width-(pright+pleft),pjob.getPageDimension().height-(pbottom+ptop));

   
      	   if (pg != null) {  pg.setFont (Fhelv);  }
	  
	      curHeight = margin;    
	      //imageht = 0;
	      

          }

     //curHeight += _Fontheight;
		  
	if ((pageNum == 1)&&(curHeight!=0)) {curHeight+=_Fontheight;}
        else if ((pageNum != 1)&&(curHeight!=0)){curHeight+=_Fontheight;}else
	      curHeight =curHeight + _Fontheight - _FontLeading;
    
    pg.drawString (imgfile, margin, (curHeight - _FontDescent));
            linesForThisPage++;
            linesForThisJob++; 
    
    //curHeight += (pg.getFontMetrics(helv).getHeight());
    pg.setFont (helv);
    fm = pg.getFontMetrics(helv);
    
    
continue;
//*****************************************************************************************************************//	   
// drawString
//*****************************************************************************************************************//	   
}else{
    
	if ((pageNum == 1)&&(curHeight!=0)) {curHeight+=fontHeight;}
        else if ((pageNum != 1)&&(curHeight!=0)){curHeight+=fontHeight;}else
	      curHeight=curHeight+fontHeight-fm.getLeading();
    
            pg.drawString (nextLine, margin, curHeight- fontDescent);
            linesForThisPage++;
            linesForThisJob++; 
            }
//*****************************************************************************************************************//	   
          } else {
            System.out.println ("pg null");
          }
        }
      } while (nextLine != null);
    } catch (EOFException eof) {
      // Fine, ignore
    } catch (Throwable t) { // Anything else
      t.printStackTrace();
    }
    
  }
    

}
